#!/usr/bin/perl -w
use strict;
use IO::Socket::INET;
use threads;

my $socket = IO::Socket::INET->new(LocalAddr => "127.0.0.1",
                                   LocalPort => 1234,
                                   Listen    => 5) ||
    die "Could not listen on 127.0.0.1:1234: $!\n";

while (1) {
    my $accepted = $socket->accept;
    if (!$accepted) {
        print STDERR "Error accepting connection: $!\n";
        next;
    }
    my $thr = threads->new(\&process_request, $socket, $accepted);
    $thr->detach;
    close($accepted);
}

sub process_request {
    my ($socket, $accepted) = @_;
    close $socket;
    my $peer_port = $accepted->peerport;
    my $peer_ip   = $accepted->peerhost;
    print STDERR "Pid $$, received a connection from $peer_ip:$peer_port\n";
    print $accepted "Hello $peer_ip:$peer_port\n";
    sleep 5;
    close($accepted);
}
